#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned int getWord( FILE* );
unsigned int getDWord( FILE* );
void putBmp( unsigned int n, unsigned char *bmp );

static unsigned char PalmOsBMP[] = {
0x42,0x4D,
0x36,0xB0,0x04,0x00,0x00,0x00,0x00,0x00,0x36,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0x40,0x01,0x00,0x00,0x40,0x01,0x00,0x00,0x01,0x00,0x18,0x00,0x00,0x00,
0x00,0x00,0x00,0xB0,0x04,0x00,0x13,0x0B,0x00,0x00,0x13,0x0B,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00
};

// RGBe[u (PalmOS) ---------
unsigned char cv5to8[] = { 
	0,9,18,27,36,45,54,63,
	64,73,82,91,100,109,118,127,
	128,137,146,155,164,173,182,191,
	192,201,210,219,228,237,246,255 };

unsigned char cv6to8[] = {
	0,5,10,15,16,21,26,31,
	32,37,42,47,48,53,58,63,
	64,69,74,79,80,85,90,95,
	96,101,106,111,112,117,122,127,
	128,133,138,143,144,149,154,159,
	160,165,170,175,176,181,186,191,
	192,197,202,207,208,213,218,223,
	224,229,234,239,240,245,250,255 };

// RGBe[u (ϓŁFgp) ---------
//unsigned char cv5to8[] = { 
//	0,8,16,25,33,41,49,58,
//	66,74,82,90,99,107,115,123,
//	132,140,148,156,165,173,181,189,
//	197,206,214,222,230,239,247,255 };
//
//unsigned char cv6to8[] = {
//	0,4,8,12,16,20,24,28,
//	32,36,40,45,49,53,57,61,
//	65,69,73,77,81,85,89,93,
//	97,101,105,109,113,117,121,125,
//	130,134,138,142,146,150,154,158,
//	162,166,170,174,178,182,186,190,
//	194,198,202,206,210,215,219,223,
//	227,231,235,239,243,247,251,255 };

void main( int AC,  char *AV[] ) {
	FILE* ifp;	// input file pointer
	unsigned int num;	// record num
	unsigned int ofs;	// record offset
	unsigned int i;
	unsigned int j;
	unsigned char bmp[320*320*2];
	unsigned char dbname[129];

	if (AC == 1)
		strcpy( dbname, "picl16TDB.pdb" );
	else
		strcpy( dbname, AV[1] );

	if ((ifp=fopen( dbname, "rb" ))==0) {
		puts( "file not found." );
		exit(1);
	}
	if (fseek( ifp, 0x4C, SEEK_SET ) != 0) {
		puts( "file too short." );
		exit(1);
	}
	num = getWord( ifp );

	for (i=0; i<num; i+=4) {
		if (fseek( ifp, 0x4E+8*i, SEEK_SET ) != 0) {
			puts( "file too short." );
			exit(1);
		}
		ofs = getDWord( ifp );
		if (fseek( ifp, ofs, SEEK_SET ) != 0) {
			puts( "file too short." );
			exit(1);
		}
		for (j=0; j<320*320*2; j++) {
			bmp[j] = fgetc( ifp );
		}
		putBmp( i/4, bmp );
	}
	
	fclose( ifp );
}

unsigned int getWord( FILE* fp ) {
	unsigned int ret;
	ret = fgetc( fp );
	ret <<= 8;
	ret += fgetc( fp );
	return ret;
}
unsigned int getDWord( FILE* fp ) {
	unsigned int ret;
	ret = fgetc( fp );
	ret <<= 8;
	ret += fgetc( fp );
	ret <<= 8;
	ret += fgetc( fp );
	ret <<= 8;
	ret += fgetc( fp );
	return ret;
}

void putBmp( unsigned int n, unsigned char *bmp ) {
	FILE* ofp;	// output file pointer
	int i,j;
	char fname[128];
	unsigned int wd;
	unsigned char r,g,b;
	sprintf( fname, "pxmkt_%03d.bmp", n );
	if ((ofp=fopen( fname, "wb" ))==0) {
		puts( "ofp can't open." );
		exit(1);
	}
	for (i=0; i<sizeof PalmOsBMP; i++) {
		if (fputc( PalmOsBMP[i], ofp ) == EOF) {
			puts( "ofp can't write." );
			exit(1);
		}
	}
	bmp += 320*319*2;    /* ŉs̍[Ɉړ */
	for (i=0; i<320; i++) {
		for (j=0; j<320; j++) {
			wd = (*bmp) + (*(bmp+1)*256);   /* gGfBA */
			r = cv5to8[wd >> 11];
			g = cv6to8[(wd >> 5) & 0x003f];
			b = cv5to8[wd & 0x001f];
			if (fputc( b, ofp ) == EOF) {
				puts( "ofp can't write." );
				exit(1);
			}
			if (fputc( g, ofp ) == EOF) {
				puts( "ofp can't write." );
				exit(1);
			}
			if (fputc( r, ofp ) == EOF) {
				puts( "ofp can't write." );
				exit(1);
			}
			bmp += 2;
		}
		bmp -= 320*2*2;
	}
	fclose( ofp );
}

